<template>
    <div class="details">
        <el-card class="box-card">
            <template v-slot:header>
                <div v-if="needHeader">
                    <details-header-list :config="headerConfig" :data="userData" />
                </div>
            </template>
            <details-collapse-tabs :sections="config.sections" v-model="activeTabs">
                <template v-slot:list_data="{ section }">
                    <details-param-list :config="section.data" :data="userData" ref="paramList" />
                </template>
                <template v-slot:bookmarks>
                     <bookmarks v-model="userData.bookmarks" ref="bookmarks" />
                </template>
                <template v-slot:subscriptions>
                    <subscriptions :data="userData.subscriptions" ref="subscriptions" />
                </template>
                <template v-slot:company_profile="{ section }">
                    <company-profile :config="section" :init-data="profileDiff" ref="companyProfile" />
                </template>
                <template v-slot:team="{ section }">
                    <team-details :init-data="teamDiff(section.labels)"  ref="teamProfile"/>
                </template>
            </details-collapse-tabs>
        </el-card>
    </div>
</template>

<script>
import { investorsFields, startupsFields, usersFields } from '@/constants/ui/details';
import { Bookmarks } from '@/components/Bookmarks';
import Subscriptions from '@/components/Subscriptions';
import TeamDetails from '@/components/TeamDetails';
import CompanyProfile from '@/components/CompanyProfile';
import DetailsParamList from './DetailsParamList';
import DetailsHeaderList from './DetailsHeaderList';
import DetailsCollapseTabs from './DetailsCollapseTabs';

export default {
    name: 'DetailsTemplate',
    components: {
        DetailsHeaderList,
        DetailsParamList,
        DetailsCollapseTabs,
        Bookmarks,
        Subscriptions,
        TeamDetails,
        CompanyProfile,
    },
    props: {
        /** user details from server */
        userData: {
            type: Object,
            required: true,
        },
        /** user type: investor/startup/user */
        userType: {
            type: String,
            required: true,
        },
    },
    watch: {
        profileData() { // redraw profile tables after data update
            this.updateCompanyProfile();
        },
    },
    created() {
        const {
            account_type: accountType,
        } = this.userData;
        const foundAccountType = ['user', 'investor', 'startup'].find(el => el === accountType);
        if (foundAccountType) {
            this.$store.commit('setActiveLinkInMenu', `${foundAccountType}s`);
        }
        this.activeTabs = this.$router.fromLoginPage ? this.$store.getters.activeCollapseSections : this.config.active;
    },
    mounted() {
        // clean up old edit data
        if (!this.$router.fromLoginPage && !this.$router.isFirstPage) {
            this.discardChanges();
        }
        if (!this.$store.getters.hasEditedProfileSections) {
            this.updateCompanyProfile();
        }
        this.$nextTick(() => { this.$emit('ready'); });
    },
    data() {
        return {
            activeTabs: [], // current opened colapse sections
        };
    },
    computed: {
        needHeader: vm => vm.config && vm.config.titleSection,
        headerConfig: vm => (vm.config.titleSection.data ? vm.config.titleSection.data : {}),
        config: (vm) => { // structure of collapse sections and fields
            if (vm.userType === 'user') {
                return usersFields;
            }
            if (vm.userType === 'investor') {
                return investorsFields;
            }
            return startupsFields;
        },
        profileData: vm => vm.userData.pending_profile,
        publishedProfileData: vm => vm.userData.published_profile,
        profileDiff: vm => ({ pending: vm.profileData, published: vm.publishedProfileData }),
        teamDiff: vm => labels => (vm.profileData.team ? vm.profileData.team.reduce((acc, obj, ind) => {
            acc.push({
                pending: obj,
                published: vm.publishedProfileData && vm.publishedProfileData.team
                    ? vm.publishedProfileData.team[ind] : '',
                labels,
            });
            return acc;
        }, []) : []),
    },
    methods: {
        /**
         * Discard changes for all sections and components on details page
         */
        discardChanges() {
            if (this.$refs.paramList) {
                this.$refs.paramList.discardChanges();
            }
            if (this.$refs.bookmarks) {
                this.$refs.bookmarks.discardChanges();
            }
            if (this.$refs.subscriptions) {
                this.$refs.subscriptions.discardChanges();
            }
            if (this.$refs.companyProfile) {
                this.$refs.companyProfile.forceDiscardChanges();
            }
            if (this.$refs.teamProfile) {
                this.$refs.teamProfile.discardChanges();
            }
        },
        /**
         * Handler for updating company profile data
         */
        updateCompanyProfile() {
            if (this.profileData) {
                this.$store.commit('updateCompanyProfileFields', this.profileData);
                this.$store.commit('updateTeamMembers', this.profileData);
            }
        },
    },
};
</script>
